
!UiButtonGroup methodsFor: 'dropping/grabbing' stamp: 'mt 10/22/2010 12:50:11.311'!
wantsDroppedMorph: aMorph event: evt

	(((aMorph isKindOf: TransferMorph)
		and: [UiButton subclasses includes: (aMorph passenger model widgetAt: aMorph passenger)])
		or: [aMorph isKindOf: UiButton])
		ifTrue: [^ super wantsDroppedMorph: aMorph event: evt].
	
	^ false! !

!UiCodeGenerator methodsFor: 'code generation' stamp: 'mt 10/22/2010 11:09:30.541'!
createAccessors

	| template |
	template := '{1}
	"{2}"
	
	^ {1}'.
	instVars
		select: [:instVar | instVar at: #hasName]
		thenDo: [:instVar |
		self uiClass compile: (template format: {
			instVar at: #name.
			instVar at: #description}) classified: 'accessing'].! !

!UiCodeGenerator methodsFor: 'private - reading' stamp: 'mt 10/22/2010 11:56:27.854'!
injectCustomUiCodeFor: aMorph into: stream

	| propertyTemplate value isCode |
	propertyTemplate := '{1} {2}: ({5}{3}{4}{6}).'.

	aMorph class widgetProperties do: [:category |
		category value do: [:property |
			isCode := false.
			property value == Form
				ifTrue: [value := aMorph valueOfProperty: (property key, #byDesigner) asSymbol ifAbsent: []. isCode := true]
				ifFalse: [value := aMorph perform: property key].

		stream crtab; nextPutAll: (propertyTemplate format: {
			aMorph valueOfProperty: #objectNameTemp.
			property key.
			value isSymbol ifTrue: ['#'] ifFalse: [''].
			value isText ifTrue: [value asString] ifFalse: [value].
			"add string quotation"
			value isSymbol not & isCode not & (value isString | value isText) ifTrue: [''''] ifFalse: [''].
			value isSymbol not & isCode not & (value isString | value isText) ifTrue: [''''] ifFalse: ['']})]].
	
! !

!UiCodeGenerator methodsFor: 'private - inst vars' stamp: 'mt 10/22/2010 11:47:36.431'!
injectInstVarsForMorph: aMorph into: aCollection

	"Root panel already has an instance variable."
	aMorph ~~ source ifTrue: [
		aMorph
			setProperty: #objectNameTemp
			toValue: (aMorph objectName ifEmpty: [self nextDefaultName]).
		
		aMorph
			setProperty: #objectDescroptionTemp
			toValue:  (aMorph objectDescription ifEmpty: ['No description given.']).
		
		aCollection add: (Dictionary newFrom: {
			#name -> (aMorph valueOfProperty: #objectNameTemp).
			#description -> (aMorph valueOfProperty: #objectDescriptionTemp).
			#hasName -> aMorph objectName notEmpty})].
	
	(aMorph isKindOf: UiContainer)
		ifTrue: [
			aMorph submorphs do: [:m | self injectInstVarsForMorph: m into: aCollection]].! !

!UiCodeGenerator methodsFor: 'private - reading' stamp: 'mt 10/22/2010 11:57:11.003'!
injectUiCodeFor: aMorph property: aProperty into: stream

	| propertyTemplate value |
	propertyTemplate := '{1} {2}: ({3}{4}).'.

	value := aMorph perform: aProperty.

	stream crtab; nextPutAll: (propertyTemplate format: {
		aMorph valueOfProperty: #objectNameTemp.
		aProperty.
		value isSymbol ifTrue: ['#'] ifFalse: [''].
		value}).! !

!UiCodeGenerator methodsFor: 'private - inst vars' stamp: 'mt 10/22/2010 11:31:31.606'!
instVarsString

	| stream |
	stream := WriteStream on: ''.
	self collectInstVars
		do: [:instVar | stream nextPutAll: (instVar at: #name)]
		separatedBy: [stream nextPut: Character space].
		
	^ stream contents
	! !

UserInterface subclass: #FuzzyUi
	instanceVariableNames: 'unnamedMorph1 unnamedMorph2 unnamedMorph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Custom'!

!FuzzyUi methodsFor: 'ui - private' stamp: 'mt 10/22/2010 11:57:16.488'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel extent: (396@547).
	panel position: (372@105).
	panel hResizing: (#spaceFill).
	panel vResizing: (#spaceFill).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiCheckBox new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (74@21).
	unnamedMorph1 position: (445@211).
	unnamedMorph1 hResizing: (#shrinkWrap).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (2@0 corner: 2@0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 icon: (nil).
	unnamedMorph1 text: ('CheckBox').
	unnamedMorph1 checkable: (true).
	unnamedMorph1 checked: (false).
	unnamedMorph1 autoExclusive: (false).
	panel addMorphBack: unnamedMorph1.
	unnamedMorph2 := UiPushButton new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (42@21).
	unnamedMorph2 position: (537@298).
	unnamedMorph2 hResizing: (#shrinkWrap).
	unnamedMorph2 vResizing: (#shrinkWrap).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (2@0 corner: 2@0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#leftToRight).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 icon: (UiSilkIcons acceptIcon).
	unnamedMorph2 text: ('OK').
	unnamedMorph2 checkable: (false).
	unnamedMorph2 checked: (false).
	unnamedMorph2 autoExclusive: (false).
	panel addMorphBack: unnamedMorph2.
	unnamedMorph3 := UiToolButton new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (66@21).
	unnamedMorph3 position: (482@364).
	unnamedMorph3 hResizing: (#shrinkWrap).
	unnamedMorph3 vResizing: (#shrinkWrap).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (2@0 corner: 2@0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#leftToRight).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 icon: (nil).
	unnamedMorph3 text: ('ToolButton').
	unnamedMorph3 checkable: (false).
	unnamedMorph3 checked: (false).
	unnamedMorph3 autoExclusive: (false).
	unnamedMorph3 autoRaise: (false).
	unnamedMorph3 buttonStyle: (#textBesideIcon).
	panel addMorphBack: unnamedMorph3.
	panel setProperty: #uiClassName toValue: 'Fuzzy'.! !

Morph subclass: #UiContainer
	instanceVariableNames: 'editMode focusRectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiContainer commentStamp: 'mt 7/13/2010 09:34:37.877' prior: 0!
I am a, normally invisible, container or owner morph for various UI elements. If I am in #editMode, I support drag&drop operations.!

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 10/23/2010 09:41:03.875'!
acceptDroppingMorph: aMorph event: evt

	| result |
	(aMorph isKindOf: TransferMorph)
		ifTrue: [ (aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self addMorphBack: widget.
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode].

			self
				changeFocusTo: widget bounds;
				changeSelectionTo: widget.
				
			^ self]].

	result := super acceptDroppingMorph: aMorph event: evt.
	
	self
		changeFocusTo: aMorph bounds;
		changeSelectionTo: aMorph.
	
	^ result! !

!UiContainer methodsFor: 'focus' stamp: 'mt 10/23/2010 09:50:30.956'!
changeFocusTo: aRectangle

	(self owner isKindOf: UiContainer)
		ifTrue: [^ self owner changeFocusTo: aRectangle].
	
	aRectangle = self bounds
		ifTrue: [focusRectangle := nil].
	
	focusRectangle := aRectangle ifNotNil: [:r | r outsetBy: (2@2)].
	self redrawLater.! !

!UiContainer methodsFor: 'selection' stamp: 'mt 10/23/2010 09:39:01.484'!
changeSelectionTo: aMorph
	"Talk to root container."

	(self owner isKindOf: UiContainer)
		ifTrue: [self owner changeSelectionTo: aMorph]
		ifFalse: [	self selectionChanged: aMorph].! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/23/2010 09:40:31.491'!
click: evt

"	| clickedMorph |
	clickedMorph := self submorphs detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	evt yellowButtonPressed ifTrue: [
		self showContextMenuForMorph: clickedMorph atHand: evt hand]."
	
	| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | (m isKindOf: UiFocusRectangle) not and: [m bounds containsPoint: evt position]] ifNone: [self].
		
	self
		changeFocusTo: clickedMorph bounds;
		changeSelectionTo: clickedMorph.! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 10/23/2010 09:57:01.871'!
drawFocusOn: aCanvas rectangle: aRect
	
	aCanvas
		frameRectangle: (aRect insetBy: 1)
		color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.8) muchDarker.
		
	aCanvas
		frameRoundRect: aRect
		radius: 3
		width: 1
		color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.5) muchDarker.! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 10/23/2010 09:53:46.303'!
drawOn: aCanvas

	super drawOn: aCanvas.

	(self editMode and: [focusRectangle notNil]) ifTrue: [
		self drawFocusOn: aCanvas rectangle: focusRectangle].! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 10/23/2010 09:52:55.973'!
editMode: aBoolean

	editMode := aBoolean.
	
	self dropEnabled: editMode.
	self dragEnabled: editMode.
	
	self submorphs
		select: [:m | m isKindOf: UiContainer]
		thenDo: [:m | m editMode: aBoolean].
		
	editMode ifTrue: [
		self color: ((Color gray: 0.3) alpha: 0.1)]! !

!UiContainer methodsFor: 'initialization' stamp: 'mt 10/23/2010 09:50:43.183'!
initialize

	super initialize.
	self
		extent: 100@100;
		color: Color transparent;
		borderWidth: 0;
		cellInset: 4;
		layoutInset: 4.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/23/2010 10:06:01.973'!
mouseDown: evt

	"| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	self submorphs do: [:m |
		m ~~ clickedMorph
			ifTrue: [m setProperty: #hasFocus toValue: false]].
	self setProperty: #hasFocus toValue: false.
	
	clickedMorph setProperty: #hasFocus toValue: true.
	self changeSelectionTo: clickedMorph."

	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. nil. nil. #startDrag:}
		threshold: 1. "pixel threshold"
		
	"self redrawLater.
	(self owner isKindOf: UiContainer) ifTrue: [self owner redrawLater]."! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 10/23/2010 09:32:50.103'!
startDrag: evt

	| morphToDrag |
	morphToDrag := self submorphs
		detect: [:m | (m isKindOf: UiFocusRectangle) not and: [m bounds containsPoint: evt position]]
		ifNone: [self dragEnabled
			ifTrue: [self]
			ifFalse: [nil]].
	
	self changeFocusTo: nil.
			
	morphToDrag ifNil: [^ self].
	
	evt redButtonPressed
		ifTrue: [evt hand grabMorph: morphToDrag].! !

Morph subclass: #UiFocusRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Support'!

!UiFocusRectangle commentStamp: 'mt 10/23/2010 09:25:50.601' prior: 0!
I am used during the edit more of a ui container to highlight the selected item.!

!UiFocusRectangle methodsFor: 'drawing' stamp: 'mt 10/23/2010 09:27:29.69'!
drawOn: aCanvas

	aCanvas
		frameRectangle: (self bounds insetBy: 1)
		color: (self color alpha: 0.8).
		
	aCanvas
		frameRoundRect: self bounds
		radius: 3
		width: 1
		color: (self color alpha: 0.5).
		! !

Morph subclass: #UiPropertyTable
	instanceVariableNames: 'nextRowColor lastMorph cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Designer'!

!UiPropertyTable methodsFor: 'updating' stamp: 'mt 10/23/2010 09:05:56.725'!
changeTableLayout: aMorph enable: aBoolean
	"More complex callback to change the layout of a morph."
	
	aBoolean
		ifTrue: [aMorph changeTableLayout.
			lastMorph := nil.
			cache removeKey: aMorph ifAbsent: [].
			self updateProperties: aMorph]
		ifFalse: [aMorph layoutPolicy: nil; layoutChanged.
			lastMorph := nil.
			cache removeKey: aMorph ifAbsent: [].
			self updateProperties: aMorph]! !

!UiPropertyTable methodsFor: 'initialization' stamp: 'mt 10/23/2010 08:59:12.578'!
clearCache

	cache := IdentityDictionary new.! !

!UiPropertyTable methodsFor: 'initialization' stamp: 'mt 10/23/2010 08:58:59.26'!
initialize

	super initialize.
	self
		color: (Color gray: 0.95);
		changeTableLayout;
		listDirection: #topToBottom;
		hResizing: #rigid;
		vResizing: #shrinkWrap.
		
	cache := IdentityDictionary new.! !

!UiPropertyTable methodsFor: 'updating' stamp: 'mt 10/22/2010 11:33:57.869'!
pickIcon: aMorph selector: aSymbol editor: aButton
	
	| codeSnippet |
	codeSnippet := UiIconPickerDialog new
		topLeft: (aButton localPointToGlobal: aButton bottomLeft);
		pickCodeForIcon.

	aMorph perform: aSymbol with: (Compiler evaluate: codeSnippet).
	aMorph setProperty: (aSymbol allButLast, #byDesigner) asSymbol toValue: codeSnippet.
	aButton icon: (Compiler evaluate: codeSnippet).! !

!UiPropertyTable methodsFor: 'updating' stamp: 'mt 10/23/2010 08:58:35.891'!
updateProperties: aMorph

	lastMorph == aMorph ifTrue: [^ self].
	lastMorph := aMorph.
	
	nextRowColor := nil.
	
	self removeAllMorphs.
	
	(cache includesKey: aMorph)
		ifFalse: [self
			addAllProperties: aMorph;
			removeIgnoredProperties: aMorph.
			cache at: aMorph put: self submorphs copy]
		ifTrue: [(cache at: aMorph) do: [:m | self addMorphBack: m]].
	
	self
		updateNameColumnWidth;
		resized.! !

!UiCheckBox methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:29:31.81'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
		
	self 
		text: 'CheckBox';
		checkable: true;
		updateSubmorphs.
		
	self connect: box signal: #toggled: toSelector: #checked:.
	box connect: self signal: #toggled: toSelector: #checked:.! !

!UiTextEdit class methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:11:31.177'!
widgetProperties

	^ {{'Custom'. #yourself} -> {
		#theText -> String}}! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/22/2010 11:24:25.666'!
chooseIconCodeAndClose: aModelIndex

	aModelIndex ifNil: [^ self delete].
	icon := iconView model codeSnippetFor: aModelIndex.
	self delete.! !

!UiIconPickerDialog methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:14:30.318'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self owner == ActiveWorld
		ifTrue: [self drawShadowOn: aCanvas].! !

!UiIconPickerDialog methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:14:03.92'!
drawShadowOn: aCanvas

	aCanvas
		line: self topRight + (0@3)
		to: self bottomRight
		color: (Color black alpha: 0.65).
		
	aCanvas
		line: self bottomLeft + (3@0)
		to: self bottomRight
		color: (Color black alpha: 0.65).
		
	aCanvas
		line: self topRight + (1@4)
		to: self bottomRight + (1@0)
		color: (Color black alpha: 0.5).
		
	aCanvas
		line: self bottomLeft + (4@1)
		to: self bottomRight + (0@1)
		color: (Color black alpha: 0.5).! !

!UiIconPickerDialog methodsFor: 'geometry' stamp: 'mt 10/22/2010 11:15:55.661'!
outerBounds

	^ self bounds outsetBy: (0@0 corner: 2@2)! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:23:55.331'!
pickCodeForIcon

	self submorphs first delete.
	self
		borderWidth: 1;
		borderColor: (Color gray: 0.8) muchDarker;
		extent: 300@200.
	
	self connect: iconView signal: #clicked: toSelector: #chooseIconCodeAndClose:.
	
	self openInWorld.
	[self isInWorld] whileTrue: [ActiveWorld doOneSubCycle].

	^icon! !

!UiStackedWidget methodsFor: 'dropping/grabbing' stamp: 'mt 10/23/2010 09:35:25.802'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: TransferMorph)
		ifTrue: [(aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self currentPage addMorphBack: widget.
			(widget isKindOf: UiContainer)
				ifTrue: [widget editMode: self editMode]]]
		ifFalse: [self currentPage addMorphBack: aMorph].
		
	"self updateCurrentPage."! !

!UiStackedWidget methodsFor: 'event handling' stamp: 'mt 10/23/2010 10:03:25.639'!
click: evt

	| clickedMorph |
	clickedMorph := self currentPage submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	clickedMorph == self
		ifTrue: [self
			changeFocusTo: self currentPage bounds;
			changeSelectionTo: self currentPage]
		ifFalse: [self
			changeFocusTo: clickedMorph bounds;
			changeSelectionTo: clickedMorph].! !

!UiStackedWidget methodsFor: 'updating' stamp: 'mt 10/23/2010 09:39:13.865'!
updateCurrentPage

	| buttonContainer |
	buttonContainer := nextPageButton owner.
	
	self
		removeAllMorphs;
		addMorphBack: self currentPage;
		addMorphFront: buttonContainer;
		changeFocusTo: self currentPage bounds;
		changeSelectionTo: self currentPage.! !

!UiViewNullSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 14:09:04.349'!
add: aCellIndex event: aUserInputEvent

	"Ignore."! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:08:50.077'!
cells

	^ #()! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:00:00.921'!
currentCell

	^ nil! !

!UiViewNullSelection methodsFor: 'accessing' stamp: 'mt 10/23/2010 10:00:08.721'!
currentCell: anIndex

! !

!UiToolButton class methodsFor: 'properties' stamp: 'mt 10/22/2010 11:40:45.982'!
widgetProperties

	^ super widgetProperties, {{'Tool Button'. #yourself} -> {
		#autoRaise -> Boolean.
		#buttonStyle -> #(iconOnly textOnly textBesideIcon textUnderIcon)}}! !

!UiToolButton methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:29:39.179'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		raised: true;
		text: 'ToolButton';
		updateSubmorphs.! !

!UiDesigner methodsFor: 'initialization' stamp: 'mt 10/23/2010 10:00:20.145'!
initialize

	super initialize.
	self
		color: (Color gray: 0.4);
		changeTableLayout;
		listDirection: #topToBottom;
		extent: 800@600.
		
	widgetList := UiTreeView new
		removeHorizontalHeader;
		model: UiWidgetListModel new;
		selectionMode: UiViewNullSelection;
		vResizing: #spaceFill;
		width: 180.
	1 to: (widgetList model rowCountFor: nil) - 1 do: [:i |
		widgetList toggleTopLevelRow: i].
	
	"BAD: Viewport should not be accessed from the outside."
	widgetList viewport dragEnabled: true.
		
	propertyTable := UiPropertyTable new.
	
	"New empty container."
	container := UiContainer new.
	self initializeContainer.
	
	self
		addMorphBack: self createToolbar;
		addMorphBack: self createMainContainer.! !

!UiDesigner methodsFor: 'save/load' stamp: 'mt 10/23/2010 09:03:19.297'!
load

	| result ui |
	propertyTable clearCache.
	
	result := ListChooser
		chooseItemFrom: UserInterface subclasses
		title: 'Select UI class'.
	
	result ifNil: [^ self].
	
	ui := result new.
	ui initializePanel.
	
	container:= ui panel.
	self initializeContainer.
	
	self submorphs second submorphs second delete.
	self submorphs second addMorph: container after: self submorphs second submorphs first.
	
	categoryEdit theText: result category.
	
	propertyTable updateProperties: container.! !

!UiDesigner methodsFor: 'save/load' stamp: 'mt 10/23/2010 09:03:25.09'!
reset

	"New empty container."
	propertyTable clearCache.
	
	container := UiContainer new.
	self initializeContainer.
	
	self submorphs second submorphs second delete.
	self submorphs second addMorph: container after: self submorphs second submorphs first.
	
	propertyTable updateProperties: container.! !

!UiPushButton methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:29:23.131'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		text: 'PushButton';
		updateSubmorphs.! !

!UiComboBox methodsFor: 'as yet unclassified' stamp: 'mt 10/22/2010 11:21:18.159'!
changed

	self submorphs notEmpty ifTrue: [
		button height ~= self submorphs first
			ifTrue: [button height: self submorphs first height]].
		
	super changed.! !

!UiComboBox methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:18:07.179'!
drawOn: aCanvas

	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: 1
		color: self color muchDarker.! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 10/22/2010 11:20:31.02'!
updateSubmorphs

	self removeAllMorphs.
	
	self
		addMorphBack: (self readOnly ifTrue: [readOnlyButton] ifFalse: [lineEdit]);
		addMorphBack: button.! !
