
!UiButtonGroup methodsFor: 'dropping/grabbing' stamp: 'mt 7/1/2010 08:06:45.482'!
wantsDroppedMorph: aMorph event: evt

	(aMorph isKindOf: UiButton)
		ifTrue: [^ super wantsDroppedMorph: aMorph event: evt].
	
	^ false! !

!UiCodeGenerator methodsFor: 'code generation' stamp: 'mt 6/27/2010 12:46:06.54'!
createAccessors

	| template |
	template := '{1}
	"{2}"
	
	^ {1}'.
	instVars do: [:instVarName |
		self uiClass compile: (template format: {
			instVarName key.
			instVarName value}) classified: 'accessing'].! !

!UiCodeGenerator methodsFor: 'private - reading' stamp: 'mt 7/21/2010 11:36:02.345'!
injectCustomUiCodeFor: aMorph into: stream

	| propertyTemplate value |
	propertyTemplate := '{1} {2}: {5}{3}{4}{6}.'.

	aMorph class widgetProperties do: [:category |
		category value do: [:property |
			value := aMorph perform: property key.

		stream crtab; nextPutAll: (propertyTemplate format: {
			aMorph valueOfProperty: #objectNameTemp.
			property key.
			value isSymbol ifTrue: ['#'] ifFalse: [''].
			value.
			"add string quotation"
			value isString | value isText ifTrue: [''''] ifFalse: [''].
			value isString | value isText ifTrue: [''''] ifFalse: ['']})]].! !

!UiCodeGenerator methodsFor: 'private - inst vars' stamp: 'mt 10/19/2010 16:38:38.79'!
injectInstVarsForMorph: aMorph into: aCollection

	"Root panel already has an instance variable."
	aMorph ~~ source ifTrue: [
		aMorph
			setProperty: #objectNameTemp
			toValue: (aMorph objectName ifEmpty: [self nextDefaultName]).
		
		aMorph
			setProperty: #objectDescroptionTemp
			toValue:  (aMorph objectDescription ifEmpty: ['No description given.']).
		
		aCollection add: (aMorph valueOfProperty: #objectNameTemp) -> (aMorph valueOfProperty: #objectDescriptionTemp)].
	
	(aMorph isKindOf: UiContainer)
		ifTrue: [
			aMorph submorphs do: [:m | self injectInstVarsForMorph: m into: aCollection]].! !

!UiCodeGenerator methodsFor: 'private - reading' stamp: 'mt 7/21/2010 11:21:07.066'!
injectUiCodeFor: aMorph property: aProperty into: stream

	| propertyTemplate value |
	propertyTemplate := '{1} {2}: {3}{4}.'.

	value := aMorph perform: aProperty.

	stream crtab; nextPutAll: (propertyTemplate format: {
		aMorph valueOfProperty: #objectNameTemp.
		aProperty.
		value isSymbol ifTrue: ['#'] ifFalse: [''].
		value}).! !

!UiCodeGenerator methodsFor: 'private - inst vars' stamp: 'mt 6/27/2010 12:48:33.968'!
instVarsString

	| stream |
	stream := WriteStream on: ''.
	self collectInstVars
		do: [:instVarName | stream nextPutAll: instVarName key]
		separatedBy: [stream nextPut: Character space].
		
	^ stream contents
	! !

!UiViewNullSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 14:09:04.349'!
add: aCellIndex event: aUserInputEvent

	"Ignore."! !

!UiViewNullSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 14:08:50.077'!
cells

	^ #()! !

Morph subclass: #UiContainer
	instanceVariableNames: 'editMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Core'!

!UiContainer commentStamp: 'mt 7/13/2010 09:34:37.877' prior: 0!
I am a, normally invisible, container or owner morph for various UI elements. If I am in #editMode, I support drag&drop operations.!

!UiContainer methodsFor: 'dropping/grabbing' stamp: 'mt 10/21/2010 21:39:21.951'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: TransferMorph)
		ifTrue: [ (aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self addMorphBack: widget.
			(UiContainer allSubclasses includes: widgetClass)
				ifTrue: [widget editMode: self editMode].
			^ self]].

	^ super acceptDroppingMorph: aMorph event: evt.! !

!UiContainer methodsFor: 'selection' stamp: 'mt 6/30/2010 09:34:16.022'!
changeSelectionTo: aMorph
	"Talk to root container."
	
	self owner ifNotNil: [:o |
		(o isKindOf: UiContainer)
			ifTrue: [o changeSelectionTo: aMorph]
			ifFalse: [self selectionChanged: aMorph]].! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/30/2010 11:06:13.476'!
click: evt

"	| clickedMorph |
	clickedMorph := self submorphs detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	evt yellowButtonPressed ifTrue: [
		self showContextMenuForMorph: clickedMorph atHand: evt hand]."
	! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 7/1/2010 17:55:13.535'!
drawFocusOn: aCanvas rectangle: aRect
		
	aCanvas
		frameRoundRect: aRect
		radius: 3
		width: 2
		color: Color red muchDarker! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 7/4/2010 09:04:59.462'!
drawOn: aCanvas

	super drawOn: aCanvas.

	self editMode
		ifFalse: [^ self].

	(self editMode
		and: [self color = Color transparent]
		and: [self borderWidth = 0 or: [self borderColor = Color transparent]])
		ifTrue: [
			aCanvas
				frameRectangle: self bounds
				width: 1
				color: Color black].

	(self owner isKindOf: UiContainer)
		ifFalse: [^ self].
		
	(self valueOfProperty: #hasFocus ifAbsent: [false])
			ifTrue: [	self
				drawFocusOn: aCanvas
				rectangle: (self bounds outsetBy: (2@2))].! !

!UiContainer methodsFor: 'accessing' stamp: 'mt 7/4/2010 09:07:19.298'!
editMode: aBoolean

	editMode := aBoolean.
	
	self dropEnabled: editMode.
	self dragEnabled: editMode.
	
	self submorphs
		select: [:m | m isKindOf: UiContainer]
		thenDo: [:m | m editMode: aBoolean].! !

!UiContainer methodsFor: 'drawing' stamp: 'mt 7/1/2010 17:53:27.82'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas.
	
	self submorphs do: [:m |
		(m valueOfProperty: #hasFocus ifAbsent: [false])
			ifTrue: [	self
				drawFocusOn: aCanvas
				rectangle: (m bounds outsetBy: (2@2))]].! !

!UiContainer methodsFor: 'initialization' stamp: 'mt 6/30/2010 10:56:50.097'!
initialize

	super initialize.
	self
		extent: 100@100;
		color: Color transparent;
		borderWidth: 0;
		cellInset: 4;
		layoutInset: 4.! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/30/2010 09:34:24.897'!
mouseDown: evt

	| clickedMorph |
	clickedMorph := self submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	self submorphs do: [:m |
		m ~~ clickedMorph
			ifTrue: [m setProperty: #hasFocus toValue: false]].
	self setProperty: #hasFocus toValue: false.
	
	clickedMorph setProperty: #hasFocus toValue: true.
	self changeSelectionTo: clickedMorph.

	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 1. "pixel threshold"
		
	self redrawLater.
	(self owner isKindOf: UiContainer) ifTrue: [self owner redrawLater].! !

!UiContainer methodsFor: 'event handling' stamp: 'mt 6/30/2010 08:53:39.306'!
startDrag: evt

	| morphToDrag |
	morphToDrag := self submorphs
		detect: [:m | m bounds containsPoint: evt position]
		ifNone: [self dragEnabled
			ifTrue: [self]
			ifFalse: [nil]].
			
	morphToDrag ifNil: [^ self].
	
	evt redButtonPressed
		ifTrue: [evt hand grabMorph: morphToDrag].! !

Morph subclass: #UiPropertyTable
	instanceVariableNames: 'nextRowColor lastMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Designer'!

!UiPropertyTable methodsFor: 'updating' stamp: 'mt 7/16/2010 11:15:14.299'!
changeTableLayout: aMorph enable: aBoolean
	"More complex callback to change the layout of a morph."
	
	aBoolean
		ifTrue: [aMorph changeTableLayout. lastMorph := nil. self updateProperties: aMorph]
		ifFalse: [aMorph layoutPolicy: nil; layoutChanged. lastMorph := nil. self updateProperties: aMorph]! !

!UiPropertyTable methodsFor: 'initialization' stamp: 'mt 7/16/2010 10:56:15.221'!
initialize

	super initialize.
	self
		color: (Color gray: 0.95);
		changeTableLayout;
		listDirection: #topToBottom;
		hResizing: #rigid;
		vResizing: #shrinkWrap.! !

!UiPropertyTable methodsFor: 'updating' stamp: 'mt 10/21/2010 22:14:32.779'!
pickIcon: aMorph selector: aSymbol editor: aButton
	
	| icon |
	icon := UiIconPickerDialog new
		topLeft: (aButton localPointToGlobal: aButton bottomLeft);
		pickIcon.

	aMorph perform: aSymbol with: icon.
	aButton icon: icon.! !

!UiPropertyTable methodsFor: 'updating' stamp: 'mt 10/21/2010 21:46:23.515'!
updateProperties: aMorph

	lastMorph == aMorph ifTrue: [^ self].
	lastMorph := aMorph.
	
	self
		removeAllMorphs;
		addAllProperties: aMorph;
		removeIgnoredProperties: aMorph;
		updateNameColumnWidth;
		resized.! !

!UiCheckBox methodsFor: 'initialization' stamp: 'mt 9/18/2010 16:15:35.458'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
		
	self 
		icon: UiSilkIcons diskIcon;
		text: 'CheckBox';
		checkable: true;
		updateSubmorphs.
		
	self connect: box signal: #toggled: toSelector: #checked:.
	box connect: self signal: #toggled: toSelector: #checked:.! !

!UiStackedWidget methodsFor: 'dropping/grabbing' stamp: 'mt 10/21/2010 21:44:16.535'!
acceptDroppingMorph: aMorph event: evt

	(aMorph isKindOf: TransferMorph)
		ifTrue: [(aMorph passenger model widgetAt: aMorph passenger) ifNotNil: [:widgetClass |
			| widget |
			widget := widgetClass new position: evt position.
			self currentPage addMorphBack: widget.
			(UiContainer allSubclasses includes: widgetClass)
				ifTrue: [widget editMode: self editMode]]]
		ifFalse: [self currentPage addMorphBack: aMorph].
		
	"self updateCurrentPage."! !

!UiStackedWidget methodsFor: 'event handling' stamp: 'mt 7/14/2010 10:46:08.182'!
mouseDown: evt

	| clickedMorph |
	clickedMorph := self currentPage submorphs
		detect: [:m | m bounds containsPoint: evt position] ifNone: [self].
	
	self currentPage submorphs do: [:m |
		m ~~ clickedMorph
			ifTrue: [m setProperty: #hasFocus toValue: false]].
	self setProperty: #hasFocus toValue: false.
	
	clickedMorph setProperty: #hasFocus toValue: true.
	
	clickedMorph == self
		ifTrue: [self changeSelectionTo: self currentPage]
		ifFalse: [self changeSelectionTo: clickedMorph].

	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 1. "pixel threshold"
		
	self redrawLater.
	(self owner isKindOf: UiContainer) ifTrue: [self owner redrawLater].! !

!UiStackedWidget methodsFor: 'updating' stamp: 'mt 7/16/2010 13:20:09.344'!
updateCurrentPage

	| buttonContainer |
	buttonContainer := nextPageButton owner.
	
	self
		removeAllMorphs;
		addMorphBack: self currentPage;
		addMorphFront: buttonContainer;
		changeSelectionTo: self currentPage.! !

!UiToolButton class methodsFor: 'properties' stamp: 'mt 10/21/2010 21:30:48.857'!
widgetProperties

	^ super widgetProperties, {{'Tool Button'. #yourself} -> {
		#autoRaise -> Boolean}}! !

!UiToolButton methodsFor: 'initialization' stamp: 'mt 9/18/2010 16:15:22.906'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		raised: true;
		text: 'ToolButton';
		icon: UiSilkIcons diskIcon;
		updateSubmorphs.! !

!UiDesigner methodsFor: 'initialization' stamp: 'mt 10/19/2010 15:44:39.397'!
initialize

	super initialize.
	self
		color: (Color gray: 0.4);
		changeTableLayout;
		listDirection: #topToBottom;
		extent: 800@600.
		
	widgetList := UiTreeView new
		removeHorizontalHeader;
		model: UiWidgetListModel new;
		vResizing: #spaceFill;
		width: 180.
	1 to: (widgetList model rowCountFor: nil) - 1 do: [:i |
		widgetList toggleTopLevelRow: i].
	
	"BAD: Viewport should not be accessed from the outside."
	widgetList viewport dragEnabled: true.
		
	propertyTable := UiPropertyTable new.
	
	"New empty container."
	container := UiContainer new.
	self initializeContainer.
	
	self
		addMorphBack: self createToolbar;
		addMorphBack: self createMainContainer.! !

!UiDesigner methodsFor: 'save/load' stamp: 'mt 7/4/2010 09:09:40.629'!
load

	| result ui |
	result := ListChooser
		chooseItemFrom: UserInterface subclasses
		title: 'Select UI class'.
	
	result ifNil: [^ self].
	
	ui := result new.
	ui initializePanel.
	
	container:= ui panel.
	self initializeContainer.
	
	self submorphs second submorphs second delete.
	self submorphs second addMorph: container after: self submorphs second submorphs first.
	
	categoryEdit theText: result category.! !

!UiDesigner methodsFor: 'save/load' stamp: 'mt 7/4/2010 09:00:43.718'!
reset

	"New empty container."
	container := UiContainer new.
	self initializeContainer.
	
	self submorphs second submorphs second delete.
	self submorphs second addMorph: container after: self submorphs second submorphs first.! !

!UiPushButton methodsFor: 'initialization' stamp: 'mt 9/18/2010 16:15:28.918'!
initialize

	super initialize.
	
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4;
		layoutInset: (2@0 corner: 2@0).
	
	self
		color: (Color gray: 0.8);
		icon: UiSilkIcons diskIcon;
		text: 'PushButton';
		updateSubmorphs.! !

!UiComboBox methodsFor: 'drawing' stamp: 'mt 10/21/2010 21:21:49.28'!
drawOn: aCanvas

	button height ~= self submorphs first
		ifTrue: [button height: self submorphs first height].

	aCanvas
		frameRoundRect: self outerBounds
		radius: 3
		width: 1
		color: self color muchDarker.! !

!UiComboBox methodsFor: 'updating' stamp: 'mt 10/19/2010 19:13:42.042'!
updateSubmorphs

	self removeAllMorphs.
	
	self
		addMorphBack: (self readOnly ifTrue: [readOnlyButton] ifFalse: [lineEdit]);
		addMorphBack: button.! !
